<template>
  <v-col>
    <v-col class="mb-2">
      <v-row align="end">
        <label v-if="detallecliente">
          Compras realizadas
        </label>
        <v-btn :block="$vuetify.breakpoint.smAndDown" color="accent" @click="dialogPeriodo=true">
          Filtrar período
        </v-btn>
        <v-spacer />
        <v-text-field
          v-if="!detallecliente"
          v-model="search"
          append-icon="fal fa-search"
          label="Buscar"
          single-line
          color="accent"
          hide-details
          style="max-width: 40vh"
        />
      </v-row>
    </v-col>
    <v-data-table
      :items-per-page="10"
      :headers="detallecliente ? headersCliente : headers"
      :items="detallecliente ? ventaCliente : ventas"
      :search="search"
      sort-by="created_at"
      sort-desc
      class="elevation-1"
    >
      <template #[`item.total`]="props">
        $ {{ props.item.total }}
      </template>
      <template #[`item.action`]="{ item }">
        <v-icon
          small
          class="fal fa-trash-alt"
          @click="eliminarVenta(item.idventas)"
        />
      </template>
    </v-data-table>
    <v-dialog v-model="dialogDetalle" width="1000" :fullscreen="$vuetify.breakpoint.smAndDown">
      <detalle-ventas v-if="dialogDetalle" :detalle="detalleVentas" @onClose="dialogDetalle = false" />
    </v-dialog>
    <v-dialog v-model="dialogPeriodo" width="1000" :fullscreen="$vuetify.breakpoint.smAndDown">
      <filtro-periodo v-if="dialogPeriodo" @onClose="dialogPeriodo = false" />
    </v-dialog>
  </v-col>
</template>

<script lang="ts">
import { Component, Prop, Vue } from 'vue-property-decorator'
import { ClientesStore } from '~/store/ClientesStore'
import AppToast from '~/core/utils/AppToast'
import { Venta } from '~/core/models/venta'
import { VentasStore } from '~/store/VentasStore'
import DetalleVentas from '~/components/ventas/detalleVentas.vue'
import { Cliente } from '~/core/models/cliente'
import { DateHelpers } from '~/core/helpers/DateHelpers'
import FiltroPeriodo from '~/components/ventas/filtroPeriodo.vue'
    @Component({
      components: { FiltroPeriodo, DetalleVentas }
    })
export default class listaVentas extends Vue {
        @Prop({ default: false }) detallecliente!:boolean;
        @Prop({ default: false }) clientedetalle!:Cliente;

        search = '';

        headersCliente = [
          { text: 'ID', align: 'left', value: 'idventas' },
          { text: 'Fecha', align: 'left', value: 'fecha' },
          { text: 'Total', align: 'left', value: 'total' },
          { value: 'action', align: 'right', sortable: false }
        ];

        headers = [
          { text: 'ID', align: 'left', value: 'idventas' },
          { text: 'Cliente', align: 'left', value: 'cliente' },
          { text: 'DNI', align: 'left', value: 'dni' },
          { text: 'Fecha', align: 'left', value: 'fecha' },
          { text: 'Total', align: 'left', value: 'total' },
          { value: 'action', align: 'right', sortable: false }
        ];

        dialogDetalle:boolean = false;
        dialogPeriodo:boolean = false;
        detalleVentas:any[] = [];

        get ventaCliente ():Venta[] {
          return this.ventas.filter(p => p.clientes_idclientes === this.clientedetalle.idclientes)
        }

        get ventas ():Venta[] {
          return VentasStore.listaVentas.map((p, index) => {
            const x = ClientesStore.listaClientesIndexed[p.clientes_idclientes]
            return {
              ...p,
              cliente: x ? x.nombre : 'Desconocido',
              dni: x ? x.dni : 'Desconocido',
              fecha: DateHelpers.convertHumanFecha(p.fecha),
              index
            }
          })
        }

        eliminarVenta (id:number) {
          this.$confirm('¿Está seguro?').then(async (res) => {
            if (res) {
              await VentasStore.eliminarVenta(id)
              AppToast.info('Venta eliminada')
            }
          }).catch()
        }

        mostrarDetalle (detalle) {
          this.detalleVentas = detalle.detalle
          this.dialogDetalle = true
        }

        imprimirHistorial () {
          this.$emit('onHistorial')
        }
}
</script>

<style lang="scss">

</style>
